package com.hywa.banktest.bankframework.utils.rsa;

import org.apache.log4j.Logger;

import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import java.security.spec.AlgorithmParameterSpec;

/**
 * 
 * 版权所有：2016-贵州精英天成科技股份有限公司
 * 项目名称：plamsa-common   
 *
 * 类描述：
 * 类名称：com.elite.common.utils.rsa.DES     
 * 创建人： xiezt 
 * 创建时间：2016年5月6日 下午5:10:30   
 * 修改人：
 * 修改时间：2016年5月6日 下午5:10:30   
 * 修改备注：   
 * @version 1.0
 */
public class DES {

	// public static final String DES_ALGORITHM = "DES/CBC/PKCS5Padding";
	// 若采用NoPadding模式，data长度必须是8的倍数
	public static final String DES_ALGORITHM = "DES/CBC/NoPadding";

	private static Logger logger = Logger.getLogger(DES.class);

	/**
	 * DES-CBC模式加密
	 * 
	 * @param plainData
	 *            明文
	 * @param keyData
	 *            密钥
	 * @param ivData
	 *            初始化向量
	 * @return 密文
	 */
	public static final byte[] encryptCBC(byte[] plainData, byte[] keyData, byte[] ivData) {
		byte[] encryptData = null;

		try {
			Cipher cipher = Cipher.getInstance(DES_ALGORITHM);
			AlgorithmParameterSpec paramSpec = new IvParameterSpec(ivData);
			SecretKey key = new SecretKeySpec(keyData, "DES");// key
			cipher.init(Cipher.ENCRYPT_MODE, key, paramSpec);
			encryptData = cipher.doFinal(plainData);
		} catch (Exception e) {
			logger.error(e);
		}

		return encryptData;
	}

	/**
	 * DES-CBC模式解密
	 * 
	 * @param plainData
	 *            密文
	 * @param keyData
	 *            密钥
	 * @param ivData
	 *            初始化向量
	 * @return 明文
	 */
	public static final byte[] decryptCBC(byte[] encryptData, byte[] keyData, byte[] ivData) {
		byte[] plainData = null;

		try {
			Cipher cipher = Cipher.getInstance(DES_ALGORITHM);
			AlgorithmParameterSpec paramSpec = new IvParameterSpec(ivData);
			SecretKey key = new SecretKeySpec(keyData, "DES");// key
			cipher.init(Cipher.DECRYPT_MODE, key, paramSpec);
			plainData = cipher.doFinal(encryptData);
		} catch (Exception e) {
			logger.error(e);
		}
		return plainData;
	}

}
